<?php if(!defined('IN_GS')){ die('you cannot load this page directly.'); }
/*
Coa 1.3
Copyright © 2012 Benjamin Scherer 
www.plue.me

Modified MIT License

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, and/or sublicense, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/



/*
Contents

1. Parse template
Parse Coa files to object arrays and initiate the rendering if conditions are fine

2. Echo HTML Header
Make the Constant Objects

3. Echo HTML Body
Make the Page Objects

4. Protect Mail
Protect email addresses and links

5. Cache and Minify
Cache and compress the HTML output

6. Tags
Generates lightbox, images or thumbs from given directory

7. Fire
Fires and initiates everything
*/






////////////////////////
// 1. Parse template
////////////////////////
  
 

/* Current Page Id
 * since 1.0 */

$curPid = $_GET['id']; 
if (!$curPid) $curPid = 'index';



/* Get Objects
 * since 1.0 */

function getObjects($path) {
   $file = file($path);
   $OBJ = array();
   
   // go through each line of the file
   foreach($file as $key => $line) {

      // define objects and comment
      $providedObj = preg_match('/^main|^meta|^css|^script|^text|^menu|^image|^place|^content|^config/i', trim($line));
      $comment = '/^#/';
      
      // check for objects
      if ($providedObj && !preg_match($comment, trim($line))) {
      
            // get object type -> write to array
            $objType = trim($line);
            $objA = array();
            $objA['type'] = $objType;
               
            // get object length
            for ($i=$key; $i<$key+15; $i++) {   
               if (!trim($file[$i])) {
                  $objLength = $i-$key;
                  break;
               }
            }
            
            // get attributes and values -> write to array
            for ($k=$key; $k<$key+$objLength; $k++) {
               if (trim($file[$k]) !== '' && !preg_match($comment, trim($file[$k]))) {   
                  $attrLine = explode('=', trim($file[$k]), 2);
                  $objA[trim($attrLine[0])] = trim($attrLine[1]);   
               }
            }
            
            // push objects to array
            array_push($OBJ, $objA);
      }
   }
   
   // return objects
   return $OBJ;
}



/* Get Attributes
 * since 1.0 */

function getAttributes($OA,$curPid) {
      
      // default attributes which keep their name, 
      // e.g. $OA['value'] are available automatically
      
      // get 'wrap'
      $OA['wrapB'] = wrapB($OA['wrap']);
      $OA['wrapA'] = wrapA($OA['wrap']);

      // get 'link'         
      $l = $OA['link'];
      $OA['linkIs'] = 0;
      
      if ($l) {
         // if link has target
         if (preg_match('/,/', $l)) {
            $OA['link'] = commaB($l);
            $OA['linkT'] = commaA($l);
         } else {
            $OA['link'] = trim($l);
            $OA['linkT'] = '_top';
         }
         $OA['linkIs'] = 1; 
      }
         
      // get 'list'
      $OA['listA'] = explode(',', str_replace(' ','',$OA['list']));
         
      // get 'item'
      $OA['itemB'] = wrapB($OA['item']);
      $OA['itemA'] = wrapA($OA['item']);
         
      // get 'cur'
      $OA['curB'] = wrapB($OA['cur']);
      $OA['curA'] = wrapA($OA['cur']);
         
      // get 'act'
      $OA['actB'] = wrapB($OA['act']);
      $OA['actA'] = wrapA($OA['act']);
      
      // get 'size'
      $OA['width'] = commaB($OA['size']);
      $OA['height'] = commaA($OA['size']);

      // get prepared for 'css' and 'script' attributes
      $OA_ = $OA;
      $OA['all'] = array();
      $OA['screen'] = array();
      $OA['print'] = array();
      $OA['handheld'] = array();
      $OA['js'] = array();
      
      // get 'all', 'screen', 'print', 'handheld' and 'js'
      if ($OA_['all']) $OA['all'][0] = $OA_['all'];
      if ($OA_['screen']) $OA['screen'][0] = $OA_['screen'];
      if ($OA_['handheld']) $OA['handheld'][0] = $OA_['handheld'];
      if ($OA_['print']) $OA['print'][0] = $OA_['print'];
      if ($OA_['js']) $OA['js'][0] = $OA_['js'];
      
      // get 'all[1-9]', 'screen[1-9]', 'handheld[1-9], 'print[1-9]' and 'js[1-9]'
      for ($k=1; $k<10; $k++) {
         if ($OA['all'.$k]) {
            $OA['all'][$k] = $OA['all'.$k];
            unset($OA['all'.$k]);
         }
         if ($OA['screen'.$k]) {
            $OA['screen'][$k] = $OA['screen'.$k];
            unset($OA['screen'.$k]);
         }
         if ($OA['handheld'.$k]) {
            $OA['handheld'][$k] = $OA['handheld'.$k];
            unset($OA['handheld'.$k]);
         }
         if ($OA['print'.$k]) {
            $OA['print'][$k] = $OA['print'.$k];
            unset($OA['print'.$k]);
         }
         if ($OA['js'.$k]) {
            $OA['js'][$k] = $OA['js'.$k];
            unset($OA['js'.$k]);
         }
      }

   
      ///////////////////////////////
      // get conditions
      //////////////////////////////
      
      $onlyA = explode(',', $OA['only']);
      $exclA = explode(',', $OA['exclude']);

      $ifSub = 0; $ifNoSub = 0;
      if ($OA['if'] == 'sub') $ifSub = 1;
      if ($OA['if'] == '!sub') $ifNoSub = 1; 
      
      
      ///////////////////////////////
      // check conditions
      //////////////////////////////
      
      // reset allTrue
      $OA['allTrue'] = 0;
      
      // 'only','exclude' and 'if' are fine with this object
      if ($OA['only']) {
         if (in_array($curPid, $onlyA) && !in_array($curPid, $exclA)) {
            if ($ifSub && return_parent() != '' || $ifNoSub && return_parent() == '')
               $OA['allTrue'] = 1;
            elseif (!$ifSub && !$ifNoSub)
               $OA['allTrue'] = 1;
         } 
      } elseif (!in_array($curPid, $exclA)) {
         if ($ifSub && return_parent() != '' || $ifNoSub && return_parent() == '')
            $OA['allTrue'] = 1;
         elseif (!$ifSub && !$ifNoSub)
            $OA['allTrue'] = 1;
      }
      
      // filter array
      $OA = array_filter($OA);
      
      // return object array
      return $OA;   

}



/* Get Config Object
 * since 1.0 */

function configObj($path) {
   global $curPid;
   global $USR;
   
   // get constant objects and lenght
   $OBJ = getObjects($path);
   $objLength = count($OBJ);
   
   // create arrays
   $OA = array();
   $configOA = array();

   // for each object
   for ($i=0; $i<$objLength; $i++) {

      // create $OA and get attributes
      $OA = $OBJ[$i];
      $OA = getAttributes($OA,$curPid);


      ///////////////////////////////
      // make config object
      //////////////////////////////
      
      if ($OA['allTrue'] == 1 && $OA['type'] == 'config') {
            
            // require Login
            if ($OA['loginReq'] == 1 && !$USR) 
               header('location:'.get_site_url(false).'admin/index.php?redirect='.$_SERVER['REQUEST_URI']);
            
            // wrap page
            $configOA['wrapPageB'] = wrapB($OA['wrapPage']);
            $configOA['wrapPageA'] = wrapA($OA['wrapPage']);
            
            // minify source
            $configOA['minify'] = $OA['minify'];
            
            // html tag
            $configOA['htmlTag'] = $OA['htmlTag'];
            
            // caching
            $configOA['cache'] = $OA['cache'];
            
            // protect mail addresses
            $configOA['protMail'] = $OA['protMail'];
      }   
   
   }
   
   // return config
   return $configOA;

}



/* Initiate Constant Objects
 * since 1.0 */

function makeConstant($pathConstant, $configOA) {
   global $curPid;
   
   // get constant objects and lenght
   $OBJ = getObjects($pathConstant);
   $objLength = count($OBJ);
   
   // for each object
   for ($i=0; $i<$objLength; $i++) {
      
      // create object array
      $OA = array();
      $OA = $OBJ[$i];
      
      // get attributes
      $OA = getAttributes($OA,$curPid);


      ///////////////////////////////
      // make objects
      //////////////////////////////
      
      if ($OA['allTrue'] == 1) {
      
         if ($OA['type'] == 'main') {
            if (!$OA['language']) $OA['language'] = 'en';
            mainObj($OA,$configOA);
         }
      
         if ($OA['type'] == 'meta') metaObj($OA);
         if ($OA['type'] == 'css') cssObj($OA);
         if ($OA['type'] == 'script') scriptObj($OA);
         if ($OA['type'] == 'text') textObj($OA);
      }   
   
   }
   
   // return header end
   headEnd($configOA);
}



/* Initiate Page Objects
 * since 1.0 */

function makePage($path, $configOA, $isPlace) {
   global $curPid;

   // get template objects and lenght
   $OBJ = getObjects($path);
   $objLength = count($OBJ);
   
   // for each object
   for ($i=0; $i<$objLength; $i++) {
      
      // create object array
      $OA = array();
      $OA = $OBJ[$i];
      
      // get attributes
      $OA = getAttributes($OA,$curPid);


      ///////////////////////////////
      // make objects
      //////////////////////////////
      
      if ($OA['allTrue'] == 1) {
         if ($OA['type'] == 'text') textObj($OA);
         if ($OA['type'] == 'menu') menuObj($OA);
         if ($OA['type'] == 'image') imageObj($OA);   

         if ($OA['type'] == 'content') {
            echo $OA['wrapB'];
            
            // get default content
            if ($OA['get'] == 'one' || !$OA['get']) get_page_content();
            
            // get content of certain page
            elseif (substr($OA['get'],0,5) == 'page:') get_content_of_page(trim(substr($OA['get'],5)));
            
            // get component
            else get_component($OA['get']);
            echo $OA['wrapA']."\n\n"; 
         }
      
         if ($OA['type'] == 'place') placeObj($OA);
         if ($OA['type'] == 'script') scriptObj($OA);
      }
   
   }
   
   
   ///////////////////////////////
   // echo document end
   //////////////////////////////
   
   if ($isPlace == 0) {
   
      // wrap page
      if ($configOA['wrapPageB']) echo "\n".$configOA['wrapPageA']."\n";
      else echo "\n";
      
      // GS footer
      get_footer();
      echo "\n";
      
      // mail protection
      if ($configOA['protMail'] == 2) mailToJS();
      
      // remove html class 'no_js'
      if($configOA['htmlTag'] == 'ieClass') {
         echo '<script>/*<![CDATA[*/document.getElementsByTagName("html")[0].className='.
            'document.getElementsByTagName("html")[0].className.replace(/(?:^|\s)no_js(?!\S)/,\'\');/*]]>*/</script>'."\n";
      }

      // end tags
      echo '</body>'."\n".'</html>';
   }
   
}



/* wrapB and wrapA
 * since 1.0 */
 
function wrapB($x) {
   return trim(substr($x, 0, strpos($x, '|')));
}

function wrapA($x) {
   return trim(substr($x, strpos($x, '|')+1));
}



/* commaB and commaA
 * since 1.0 */
 
function commaB($x) {
   return trim(substr($x, 0, strpos($x, ',')));
}

function commaA($x) {
   return trim(substr($x, strpos($x, ',')+1));
}



/* Get config object
 * since 1.0 */
 
$configOA = configObj($pathConstant);









//////////////////////////
// 2. Echo HTML Header
//////////////////////////



/* Main Object
 * since 1.0 */

function mainObj($OA,$configOA) {
         
   // globalsGS
   global $title;
   global $SITENAME;
   global $pathTheme;
   
   // vars
   $cB = '<!--[if ';
   $cE = '<![endif]-->';
   
   // doctype and attribute "language"
   $htmlB = '<html lang="' .$OA['language'];
   echo '<!doctype html>'."\n";
   
   if ($configOA['htmlTag'] == 'ieClass') {
      echo $cB.'lt IE 7 ]>' .$htmlB. '" class="ie ie6 no_js">'.$cE."\n".
          $cB.'IE 7 ]>' .$htmlB. '" class="ie ie7 no_js">'.$cE."\n".
         $cB.'IE 8 ]>' .$htmlB. '" class="ie ie8 no_js">'.$cE."\n".
          $cB.'IE 9 ]>' .$htmlB. '" class="ie ie9 no_js">'.$cE."\n".
          $cB.'(gt IE 9)|!(IE)]><!-->' .$htmlB. '" class="no_js"><!--'.$cE;
   } elseif ($configOA['htmlTag']) {
      echo $configOA['htmlTag'];
   } else {
      echo $htmlB.'">';
   }
         
   // header begin
   echo "\n".'<head>'."\n";
   
   // attribute "charset"
   if ($OA['charset']) 
      echo '<meta charset="'. $OA['charset'] .'">'."\n";
   
   // latest IE rendering engine and chrome frame
   echo '<!--[if IE]><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><![endif]-->'."\n";
            
   // page title
   echo '<title>';
   $site = trim(stripslashes($SITENAME));
   $page = strip_tags(strip_decode($title));
   $temp = str_replace('%page', $page, $OA['title']);
   echo str_replace('%site', $site, $temp);
   echo '</title>'."\n";
         
   // attribute "base" 
   if (!$OA['base']) {
      echo '<base href="';
      get_site_url();
      echo '">'."\n";
   } else {
      echo '<base href="' .$OA['base']. '">'."\n";
   }
   
   // attribute "favicon"
   if ($OA['favicon'])
      echo '<link rel="shortcut icon" href="'. $pathTheme.$OA['favicon'] .'">'."\n";
   
}



/* Meta Object
 * since 1.0 */

function metaObj($OA) {
   
   $metaB = '<meta name="';
      
   // attribute "viewport"
   if ($OA['viewport'])
      echo $metaB.'viewport" content="'. $OA['viewport'] .'">'."\n";
         
   // attribute "robots"
   if ($OA['robots'])
      echo $metaB.'robots" content="'. $OA['robots'] .'">'."\n";
         
   // attribute "description"
   if ($OA['description'])
      echo $metaB.'description" content="'. $OA['description'] .'">'."\n";
         
   // attribute "kewords"
   if ($OA['keywords'])
      echo $metaB.'keywords" content="'. $OA['keywords'] .'">'."\n";
   
   // GS header as default   
   if(!$OA['headerGS']) $OA['headerGS']=1;
   
   // GS header or canonical
   if($OA['headerGS'] == 1) get_header();
   else echo '<link rel="canonical" href="'.get_page_url(true).'">'."\n";

}



/* Make CSS
 * since 1.3 */

function makeCSS($value,$mediaTag) {
   global $pathTheme;
   
   // check for absolute path
   if (substr($value,0,4) == 'http') $pathT = '';
   else $pathT = $pathTheme;

   // echo css tag
   echo $OA['wrapB']. '<link rel="stylesheet" href="'. $pathT . $value .'"'. $mediaTag .'>'.$OA['wrapA']."\n";
}



/* CSS Object
 * since 1.0 */

function cssObj($OA) {
   global $pathTheme;
   $cssB = '<link rel="stylesheet" href="';
         
   // attribute 'all', 'print', 'screen' or 'handheld'
   for ($k=0; $k<10; $k++) {
      if ($OA['all'][$k]) {
         $mediaTag = '';
         makeCSS($OA['all'][$k], $mediaTag);
      }
      
      if ($OA['print'][$k]) {
         $mediaTag = ' media="print"';
         makeCSS($OA['print'][$k], $mediaTag);
      }
      
      if ($OA['screen'][$k]) {
         $mediaTag = ' media="screen"';
         makeCSS($OA['screen'][$k], $mediaTag);
      }
      
      if ($OA['handheld'][$k]) {
         $mediaTag = ' media="handheld"';
         makeCSS($OA['handheld'][$k], $mediaTag);
      }
   }
}



/* Script Object
 * since 1.0 */

function scriptObj($OA) {
   global $pathTheme;
         
   // attribute 'js'
   for ($k=0; $k<10; $k++) {
      if ($OA['js'][$k]) {
         
         // check for absolute path
         if (substr($OA['js'][$k],0,4) == 'http') $pathT = '';
         else $pathT = $pathTheme;
         
         echo $OA['wrapB']. '<script src="' . $pathT . $OA['js'][$k] .'"></script>'.$OA['wrapA']."\n";
      }
   }
}



/* Header End
 * since 1.0 */

function headEnd($configOA) {
   global $url;
   
   echo '</head>'."\n\n".'<body id="'.$url.'">'."\n";
   if ($configOA['wrapPageB']) echo $configOA['wrapPageB']."\n";
}







////////////////////////
// 3. Echo HTML Body
////////////////////////



/* Text Objects
 * since 1.0 */

function textObj($OA) {
   
   // echo 'wrap' before
   echo $OA['wrapB'];
               
   // echo 'link' begin
   if ($OA['linkIs'] == 1)
      echo '<a href="'. $OA['link'] .'" target="'. $OA['linkT'] .'">';
   
   // echo 'data'
   $d = $OA['data'];
   $dB = commaB($d);
   $dA = commaA($d);
   
   if ($d == 'cleanTitle') { get_page_clean_title(); }
   if ($d == 'title') { get_page_title(); }
   if ($d == 'slug') { get_page_slug(); }
   if ($d == 'excerpt') { get_page_excerpt(); }
   if ($d == 'keywords') { get_page_meta_keywords(); }
   if ($d == 'description') { get_page_meta_desc(); }
   if ($d == 'parent') { get_parent(); }
   if ($d == 'url') { get_page_url(); }
   if ($d == 'theme') { get_theme_url(); }
   if ($d == 'name') { get_site_name(); }
   #if ($d == 'mail') { get_site_email(); }
   if ($d == 'date') { get_page_date(); }
   if ($dB == 'date') { get_page_date($dA); }
               
   // echo 'value'
   $v = $OA['value'];
   $v = str_replace('%title', get_page_title(false), $v);
   $v = str_replace('%cleanTitle', get_page_clean_title(false), $v);
   $v = str_replace('%title', get_page_title(false), $v);
   $v = str_replace('%slug', get_page_slug(false), $v);
   $v = str_replace('%keywords', get_page_meta_keywords(false), $v);
   $v = str_replace('%description', get_page_meta_desc(false), $v);
   $v = str_replace('%parent', get_parent(false), $v);
   $v = str_replace('%theme', get_theme_url(false), $v);
   $v = str_replace('%name', get_site_name(false), $v);   
   echo $v;
               
   // echo 'link' end
   if ($OA['linkIs'] == 1)
      echo '</a>';
               
   // echo 'wrap' after
   echo $OA['wrapA']."\n\n";    
}



/* Image Object 
 * since 1.0 */ 

function imageObj($OA) {
   global $pathTheme;

   // 'wrap' before
   if ($OA['wrapB']) echo $OA['wrapB']."\n";
               
   // if 'link' exists
   if ($OA['linkIs'] == 1)
      echo '<a href="'. $OA['link'] .'" target="'. $OA['linkT'] .'">';
      
   // check for absolute path
   if (substr($OA['file'],0,4) == 'http') $pT = '';
   else $pT = $pathTheme;
   
   // check what exists...
   if ($OA['width']) {
      echo '<img src="'. $pT . $OA['file'] .'"';
      if ($OA['width'] != 'auto') echo ' width="'. $OA['width'] .'"';
      if ($OA['height'] != 'auto') echo ' height="'. $OA['height'] .'"';
      echo ' alt="'. $OA['alt'] .'"';
      if ($OA['title']) echo ' title="'. $OA['title'] .'"';
      echo '>';
   } else {
      echo '<img src="'. $pT . $OA['file'] .'" alt="'. $OA['alt'] .'"';
      if ($OA['title']) echo ' title="'. $OA['title'] .'"';
      echo '>';
   }
               
   // if 'link' exists
   if ($OA['linkIs'] == 1)
      echo '</a>';
               
   // 'wrap' after
   if ($OA['wrapA']) echo "\n".$OA['wrapA'];
   echo "\n\n";
}



/* Place Object
 * since 1.0 */
      
function placeObj($OA) {
   global $pathTheme;
   
   // 'wrap' before
   echo $OA['wrapB'];
   
   // get file suffix
   $last4 = substr($OA['file'], -4);
   $last5 = substr($OA['file'], -5);
   $last8 = substr($OA['file'], -8);

   // check file type
   if ($last4 == '.coa' || $last8 == '.coa.php')
      makePage($pathTheme.$OA['file'], 1);
      
   elseif ($last4 == '.php' || $last4 = '.htm' || $last5 == '.html')
      include_once($pathTheme.$OA['file']);
   
   // 'wrap' end
   echo $OA['wrapA']."\n";

}



/* Menu Object 
 * since 1.0 */

function menuObj($OA) {
   global $curPid;

   // menu 'wrap' begin
   echo "\n";
   if (!$OA['wrapB']) echo '<ul>';
   echo $OA['wrapB']."\n";
   
   // make default menu
   if ($OA['mode'] == 'default') get_navigation(get_page_slug(false));
   
   // make breadcrump
   elseif ($OA['mode'] == 'breadcrump') makeBread(return_page_slug(false),1,$OA);
   
   // make hierachical menu
   else makeLi(return_page_slug(false),$OA);

   // menu 'wrap' wrap
   if (!$OA['wrapA']) echo '</ul>';
   echo $OA['wrapA']."\n\n";
}



/* Make <li> Tags 
 * since 1.0 */

// original is get_navigation() from 'admin/inc/theme_functions.php'
function makeLi($currentpage,$OA) {
   global $pagesArray;
   $menu = '';
   $pagesSorted = subval_sort($pagesArray,'menuOrder');
   
   // for each page
   if (count($pagesSorted) != 0) { 
      foreach ($pagesSorted as $page) {
         
         // check for menu status and attribute list
         if ($page['menuStatus'] == 'Y' && in_array($page['url'], $OA['listA']) || 
             $page['menuStatus'] == 'Y' && !$OA['list'] ||
             !$page['menuStatus'] == 'Y' && in_array($page['url'], $OA['listA']) ) {
            
            // if no menu title / page title
            if (!$page['menu']) $page['menu'] = $page['title'];
            if (!$page['title']) $page['title'] = $page['menu'];

            // if no parent, make <li> and go for sub
            if (!$page['parent']) {
               
               // make <li> tags and go for sub
               $menu.= liTag($currentpage,$page,$OA,0).'<a href="'.find_url($page['url'],$page['parent']).'"';
               
               // if title is 'none'
               if ($OA['title'] == 'none') $nothing = 'happens';
               else $menu.= ' title="'.strip_quotes($page['title']).'"';
               
               $menu.= '>'.$page['menu'].'</a>';
                  
               $makeSub = makeSub($page['url'],$currentpage,$OA);
               
               if ($makeSub) $menu .= '<ul>'.$makeSub.'</ul>'; 
               $menu .= liTag($currentpage,$page,$OA,1)."\n";
            }      
         }
      }
   }
   echo exec_filter('menuitems',$menu);
}



/* Make Submenu
 * since 1.0 */

// original is get_navigation() from 'admin/inc/theme_functions.php'
function makeSub($url,$currentpage,$OA) {
   global $pagesArray;
   $menu = '';
   $pagesSorted = subval_sort($pagesArray,'menuOrder');
   
   // for each page
   if (count($pagesSorted) != 0) { 
      foreach ($pagesSorted as $page) {
         if ($page['menuStatus'] == 'Y' && $page['parent']) { 
            
            // if no menu title / page title
            if (!$page['menu']) { $page['menu'] = $page['title']; }
            if (!$page['title']) { $page['title'] = $page['menu']; }
            
            // if parent found, make <li> and go for sub
            if ($url == $page['parent']) {
               $menu .= liTag($currentpage,$page,$OA,0).'<a href="'. find_url($page['url'],$page['parent']).'"';
               
               // if title is 'none'
               if ($OA['title'] == 'none') $nothing = 'happens';
               else $menu.= ' title="'.strip_quotes($page['title']).'"';
               
               $menu .= '>'.$page['menu'].'</a>';
               
               $makeSub = makeSub($page['url'],$currentpage,$OA);
               if ($makeSub) $menu .= '<ul>'.$makeSub.'</ul>'; 
               
               $menu .= liTag($currentpage,$page,$OA,1);
            }            
         }
      }
   }
   return exec_filter('menuitems',$menu);
}



/* li Tag
 * since 1.0 */

function liTag($currentpage,$page,$OA,$which) {
   
   // check if page is current
   if ($currentpage == $page['url']) { 
      if ($OA['curB']) { $liB = $OA['curB']; $liA = $OA['curA']; } 
      elseif ($OA['actB']) { $liB = $OA['actB']; $liA = $OA['actA']; }
      else { $liB = $OA['itemB']; $liA = $OA['itemA']; }
   } 
   else { 
      $liB = $OA['itemB']; $liA = $OA['itemA'];
   }

   // check if is active
   if ($OA['actB'] && hasActChild($page['url'],$currentpage) == true) {
      $liB = $OA['actB']; $liA = $OA['actA'];
   }

   // if no li defined
   if (!$liB) $liB = '<li>'; $liA = '</li>';
            
   // return li tags
   if ($which == 0) return $liB;
   elseif ($which == 1) return $liA;

}



/* Has Act Child 
 * since 1.0 */

function hasActChild($this,$currentpage) {
   global $pagesArray;
   $pagesSorted = subval_sort($pagesArray,'menuOrder');
   if (count($pagesSorted) != 0) { 
      foreach ($pagesSorted as $page) {
            
            // if there is child fot $this
            if ($page['parent'] == $this) {
            
               // child url
               $child = $page['url'];
               if ($child == $currentpage)
                  return true;
               
               if (hasActChild($child,$currentpage) == true)
                  return true;
               
            } 
      }  
   }
}



/* Make Breadcrump
 * since 1.0 */

function makeBread($currentpage,$initial,$OA) {
   global $pagesArray;
   $menu = '';
   $pagesSorted = subval_sort($pagesArray,'menuOrder');
   
   // for each page
   if (count($pagesSorted) != 0) { 
      foreach ($pagesSorted as $page) {
         $i = 1; $i <= count($pagesSorted); $i++;
         if ($page['menuStatus'] == 'Y') { 
            if ($currentpage == $page['url']) {
               
            // default item wraps
            if (!$OA['itemB']) { $OA['itemB'] = '<li>'; $OA['itemA'] = '</li>'; }
            if (!$OA['actB']) { $OA['actB'] = $OA['itemB']; $OA['actA'] = $OA['itemA']; }
            if (!$OA['curB']) { $OA['curB'] = $OA['itemB']; $OA['curA'] = $OA['itemA']; }
               
               // if no menu title / page title
               if (!$page['menu']) $page['menu'] = $page['title'];

               if (!$page['title']) $page['title'] = $page['menu'];

               // a tag with href
               if ($initial == 1) 
                  $test[$i] = $OA['curB'].'<a href="'.find_url($page['url'],$page['parent']);
               elseif ($initial == 0)
                  $test[$i] = $OA['itemB'].'<a href="'.find_url($page['url'],$page['parent']);
                  
               // if title is 'none'
               if ($OA['title'] == 'none') $nothing = 'happens';
               else $test[$i].=   '" title="'. strip_quotes($page['title']);                  
                  
               // a tag and visible text
               if ($initial == 1) 
                  $test[$i].= '">'.$page['menu'].'</a>'.$OA['curA'];
               elseif ($initial == 0) 
                  $test[$i].= '">'.$page['menu'].'</a>'.$OA['itemA'];
               
               // again for parent
               if ($page['parent']) makeBread($page['parent'],0,$OA);
               
            }
         }
      }
   }
   // echo breadcrump
   print_r($test[$i]);
}



/* Get Content of Page
 * since 1.3 */

function get_content_of_page($slug) {
    $file = @file_get_contents('data/pages/'.$slug.'.xml');
    $data = simplexml_load_string($file);
    echo stripslashes(htmlspecialchars_decode($data->content,ENT_QUOTES));
}








///////////////////////
// 4. Protect Mail
///////////////////////



/* Distort Mail (for links only)
 * since 1.0 */

function distortMail($mail) {
      
      // define condition
      $character_set = '+-.0123456789@ABCDEFGHIJKLMNOPQRSTUVWXYZ_abcdefghijklmnopqrstuvwxyz';
      $key = str_shuffle($character_set); 
      $cipher_text = ''; 
      #$id = 'e'.rand(1,999999999);
      
      // distort
      for($i=0;$i<strlen($mail);$i+=1) 
            $cipher_text.= $key[strpos($character_set,$mail[$i])];
      
      // change a tag 
     $onlick = 'href="javascript:return false" onclick="mailTo('."'".$key."','".$cipher_text."')";
      return $onlick;
}



/* Replace MailTo
 * since 1.0 */

function replaceMailTo($buffer) {

      // search for – and cut – mailto:
    $buffer = preg_replace_callback(
        '|(href="mailto:)([a-zA-Z0-9_.-]+@[a-zA-Z0-9-]+.[a-zA-Z0-9-.]+)([a-zA-Z?=%&;0-9-.]*)|',
        create_function(
            '$matches',
            'return distortMail($matches[2]);'
        ), $buffer
      );
    return $buffer;
}



/* Replace Mail with ASCII
 * since 1.0 */

function replaceMail($buffer) {
    $buffer = preg_replace_callback(
        '|(%)([a-zA-Z0-9_.-]+)(@)([a-zA-Z0-9-]+)(.)([a-zA-Z0-9-.]+)(%)|',
        create_function(
            '$matches',
            'return $matches[2].\'<span>&#064;</span>\'.$matches[4].\'<span>&#046;</span>\'.$matches[6];'
        ), $buffer
      );
    return $buffer;
}



/* Protect Mail JavaScript
 * since 1.0 */

function mailToJS() {
      
      $script = 'function mailTo(a,c){var b=a.split("").sort().join("");var d="";for(var e=0;e<c.length;e++)d+=b.charAt(a.indexOf(c.charAt(e)));window.location.href="mailto:"+d}';
      
      echo '<script>/*<![CDATA[*/'.$script.'/*]]>*/</script>'."\n";
}








//////////////////////////
// 5. Cache and Minify
//////////////////////////



/* Minify
 * since 1.0 */

function minify($buffer) {
    $search = array (
        '/\>[^\S ]+/s', // strip whitespaces after tags, except space
        '/[^\S ]+\</s', // strip whitespaces before tags, except space
        '/(\s)+/s'  // shorten multiple whitespace sequences
        );
    $replace = array (
        '>',
        '<',
        '\\1'
        );
     $buffer = preg_replace($search, $replace, $buffer);
   return $buffer;
}



/* Cache and Minify
 * since 1.0 */

if ($USR || !$configOA['cache']) $configOA['cache'] = 0;

if ($configOA['cache'] == 1) {

   // create folder
   mkdir(dirname(__FILE__).'/cache', 0770);
   
   // cache directory and file
   $cachedir = dirname(__FILE__) .'/cache/';
   if (basename($_SERVER['REQUEST_URI']) == '') define('CACHFILE', $cachedir . 'index');
   else define('CACHFILE', $cachedir . basename($_SERVER['REQUEST_URI']));

   // cachefile found
   if(is_file(CACHFILE)) {
      readfile(CACHFILE);
      exit;
   }

// else, caching is off
} else {
   $clearDir = dirname(__FILE__) .'/cache/*';
   
   // clear cache
   foreach(glob($clearDir) as $v){
       unlink($v);
   }
         
}



/* Cache Callback
 * since 1.0 */
 
function cacheCallback($buffer) {
   if(!is_file(CACHFILE)) {
      file_put_contents(CACHFILE,$buffer);
   }
    return $buffer;
}









///////////////
// 6. Tags
///////////////



/* Make Tag
 * since 1.2 */

function makeTag($buffer, $tag, $what) {
   global $pathTheme;
   $pathLightboxJs = 'js/coa.lightbox.js';
   
   if($what == 'images:') {
      $output = '<div class="coa_images">';
      $cut = 7;
   }
   if($what == 'lightbox:') {
      $output = '<div class="coa_lb">';
      $cut = 9;
   }
   if($what == 'thumbs:') {
      $output = '<span class="coa_thumbs">';
      $cut = 7;
   }
   
   // get value
   $value = trim(substr(substr($tag, strpos($tag, $what)+$cut), 0, -1));
   if(substr($value, -1) != '/') $value = $value.'/';
   
   // get path
   $path = GSDATAUPLOADPATH.$value;
   if($what == 'thumbs:') $path = GSTHUMBNAILPATH.$value;
   
   // get images and make output
   if (is_dir($path)) {
      if ($dh = opendir($path)) {
          while (($file = readdir($dh)) !== false) {
               $last4 = substr($file, -4);
               $img_ext = array('.jpg','.pdf','.gif','.png','jpeg');

               // make linked images with alt attribut
               if (in_array($last4, $img_ext)) {
               $alt_temp = str_replace($img_ext, '', $file);
               $alt = preg_replace('/[-._]/', ' ', $alt_temp);

               if($what == 'lightbox:') {
                  $output .= '<a href="data/uploads/'.$value.$file.'">';
                  $output .= '<img src="data/thumbs/'.$value.'thumbnail.'.$file.'" alt="'.$alt.'"></a>';
               }
               if($what == 'images:') {
                  $output .= '<div><h3>'.$alt.'</h3><img src="'.'data/uploads/'.$value.$file.'" alt="'.$alt.'"></div>';
               }
               if($what == 'thumbs:') {
                     if(substr($file, 0, 9) == 'thumbnail') {
                         $alt = substr($alt, 9);
                     $output .= '<span class="item"><img src="data/thumbs/'.$value.$file.'" alt="'.$alt.'"><span>'.$alt.'</span></span>';
                  }   
               }
                    
           }
          }
          closedir($dh);
      }
       
   // if path does't exist
   } else {
      $output .= 'Sorry, but this is no folder: '.$path;
   }
   
   // wrap end
   if($what == 'thumbs:') $output .= '</span>';
   else $output .= '</div>';
   
   // adjust tag for regex
   $tag = str_replace('/', '\\/', trim($tag,'[]'));
   $tag = '/(\['.$tag.'\])/';
   
   // replace tag with output
   $result = preg_replace($tag, $output, $buffer);
   
   // include lightbox javascript
   $lb_js_is = preg_match('/'.str_replace('/', '\\/', $pathLightboxJs).'/', $buffer);
   if($what == 'lightbox:' && !$lb_js_is) {
         $js_and_body = '<script src="'.$pathTheme.$pathLightboxJs.'"></script>'."\n".'</body>';
         $buffer = preg_replace('[</body>]', $js_and_body, $result);
   } else {
         $buffer = $result;
   }
   
   return $buffer;
}








///////////////
// 7. Fire
///////////////



/* Make ob_start
 * since 1.2 */
 
function make_ob_start($buffer) {
   global $configOA;
   
   // Protect Mail
   if ($configOA['protMail'] == 1 || $configOA['protMail'] == 2) $buffer = replaceMail($buffer);
   if ($configOA['protMail'] == 2) $buffer = replaceMailTo($buffer);
   
   // Minify
   if ($configOA['minify'] == 1) $buffer = minify($buffer);

   // Cache
   if ($configOA['cache'] == 1) $buffer = cacheCallback($buffer);
   
   // Replace ' />' with '>'
   $buffer = preg_replace('/ \/>/', '>', $buffer);
   
   // return buffer
   return $buffer;
}



/* ob_start Page
 * since 1.2 */
 
function ob_start_page($buffer) {

   // tag patterns
   $lb_pattern = '/(\[lightbox:[a-zA-Z_\-\/0-9\s]*[\]])/';
   $images_pattern = '/(\[images:[a-zA-Z_\-\/0-9\s]*[\]])/';
   $thumbs_pattern = '/(\[thumbs:[a-zA-Z_\-\/0-9\s]*[\]])/';
   
   // make lightbox for each tag
   $check_lb = preg_match_all($lb_pattern, $buffer, $lb_tag_a);
   foreach ($lb_tag_a[1] as $lb_tag){
      $buffer = makeTag($buffer, $lb_tag, 'lightbox:');
   }
   
   // make image for each tag
   $check_images = preg_match_all($images_pattern, $buffer, $images_tag_a);
   foreach ($images_tag_a[1] as $images_tag){
      $buffer = makeTag($buffer, $images_tag, 'images:');
   }

   // make thumbnail for each tag
   $check_thumbs = preg_match_all($thumbs_pattern, $buffer, $thumbs_tag_a);
   foreach ($thumbs_tag_a[1] as $thumbs_tag){
      $buffer = makeTag($buffer, $thumbs_tag, 'thumbs:');
   }
   
   // return buffer
   return $buffer;
}



/* Fire All
 * since 1.2 */

ob_start('make_ob_start');

makeConstant($pathConstant, $configOA);

ob_start('ob_start_page');

makePage($pathPage, $configOA, 0);

ob_end_flush();

ob_end_flush();

?>